VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{625E24A3-B09D-101D-85F5-6EBA1EE93AF4}#3.3#0"; "IniCon32.OCX"
Begin VB.Form frmMain 
   Caption         =   "SAS Conversion"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdXpoints 
      Caption         =   "Read xPoints"
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   2400
      Width           =   1215
   End
   Begin IniconLib.Init iniFile 
      Left            =   120
      Top             =   960
      _Version        =   196611
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Application     =   ""
      Parameter       =   ""
      Value           =   ""
      Filename        =   ""
   End
   Begin VB.CommandButton cmdIni 
      Caption         =   "Demo .ini"
      Height          =   495
      Left            =   360
      TabIndex        =   2
      Top             =   2400
      Width           =   975
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   495
      Left            =   3480
      TabIndex        =   0
      Top             =   2400
      Width           =   975
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   120
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblStatus 
      Height          =   735
      Left            =   1200
      TabIndex        =   1
      Top             =   600
      Width           =   2655
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'All variables MUST be declared.
'------------------------------------------------------------------------------
Option Explicit
'******************************************************************************
'* Public Function GetFileName(ByVal sFileName As String, ByVal sExtension
'*                              As String, ByVal iType As Integer) As String
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 04/30/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Gets a file name from the user using the windows common dialog
'* returns the file name to the calling function
'* Takes Default Filename, Default File Extension and type (Open/Save) as
'* arguments.
'*
'*
'******************************************************************************
Public Function GetFileName(ByVal sFileName As String, ByVal sExtension _
                            As String, ByVal iType As Integer) As String
Dim sStrTemp As String
Dim sFilter As String

'If an extension was received set extension string to use it otherwise set
'extension string to use *.*
'------------------------------------------------------------------------------
    If sExtension <> "" Then
        sFilter = "(*." & sExtension & ")|*." & sExtension & "|All Files (*.*)|*.*"
    Else
        sFilter = "All Files (*.*)|*.*"
    End If

'Display the Windows File Dialog box
'------------------------------------------------------------------------------
    On Error GoTo CancelError
    frmMain.dlgCommonDialog.Flags = cdlOFNHideReadOnly
    frmMain.dlgCommonDialog.CancelError = True
    frmMain.dlgCommonDialog.InitDir = App.Path               'Set path to current path
    frmMain.dlgCommonDialog.FileName = sFileName                'Display Default FIlename
    frmMain.dlgCommonDialog.Filter = sFilter                    'Display Extensions
    frmMain.dlgCommonDialog.DialogTitle = "Specify File Name"
    If iType = 1 Then
        frmMain.dlgCommonDialog.ShowOpen
    Else
        frmMain.dlgCommonDialog.ShowSave
    End If
    
'Set Return value to selected file path
'------------------------------------------------------------------------------
    GetFileName = frmMain.dlgCommonDialog.FileName

'Normal EXIT to this Subroutine.
'------------------------------------------------------------------------------
    Exit Function
    
'Error - Log error and exit procedure
'------------------------------------------------------------------------------
CancelError:
'    MsgBox "No File Selected - File Not Saved", vbOKOnly, "File error"
    GetFileName = ""

End Function
'******************************************************************************
'* Private Sub cmdIni_Click()
'*
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 08/11/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Function called when Demo ini button is clicked
'* Gets Excel file name
'* Read excel file and creates a demo ini for the server module.
'*
'*
'******************************************************************************
Private Sub cmdIni_Click()
Dim sExcelFile As String, sTempString As String, SType As String
Dim sName As String
Dim sSheets() As String
Dim iPos As Integer, iTemp As Integer, iLoop As Integer, iLoop2 As Integer
Dim iType As Integer, iChan As Integer, iCount As Integer
Dim iInCount As Integer, iOutCount As Integer, iConsoleCount As Integer
Dim iSlot As Integer, iFrame As Integer, iMax As Integer
Dim iConsoles(4) As Integer
Dim xclApp As Object 'Excel.Application
Dim xData As Variant
Dim xclRange As Excel.Range
Dim xclBk As Excel.Workbook         'As Object
Dim xclSht As Excel.Worksheet       'As Object

    On Error GoTo ErrorMsg

'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = ""
    DoEvents

'Open spread sheet
'------------------------------------------------------------------------------
    Set xclApp = CreateObject("Excel.Application") 'New Excel.Application
    sExcelFile = GetFileName("Excel", "xls", 1)
    If Dir(sExcelFile) = "" Then Exit Sub
    Set xclBk = xclApp.Workbooks.Open(sExcelFile) 'Path of an existing Excel File
    
'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "In Process"
    DoEvents
    
    iCount = xclBk.Worksheets.Count
    ReDim sSheets(iCount)
    For iLoop = 1 To iCount
        Set xclSht = xclBk.Worksheets(iLoop) 'Sheet on the Existing File
        sSheets(iLoop) = xclSht.Name
    Next
    
'------------------------------------------------------------------------------
'Read Sytem Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("System") 'Sheet on the Existing File
    xData = xclSht.UsedRange
    
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        If sTempString = "Name:" Then
            sName = xData(iLoop, 2)
        ElseIf sTempString = "Inputs" Then
            iInCount = Val(xData(iLoop, 2))
        ElseIf sTempString = "Outputs" Then
            iOutCount = Val(xData(iLoop, 2))
        ElseIf sTempString = "Consoles" Then
            iConsoleCount = Val(xData(iLoop, 2))
        ElseIf sTempString = "8" Then
            iConsoles(0) = Val(xData(iLoop, 2))
        ElseIf sTempString = "16" Then
            iConsoles(1) = Val(xData(iLoop, 2))
        ElseIf sTempString = "24" Then
            iConsoles(2) = Val(xData(iLoop, 2))
        ElseIf sTempString = "32" Then
            iConsoles(3) = Val(xData(iLoop, 2))
        ElseIf sTempString = "40" Then
            iConsoles(4) = Val(xData(iLoop, 2))
        End If
    Next
    
'------------------------------------------------------------------------------
'Read Frame Layout
'------------------------------------------------------------------------------
    iFrame = 1
    Set xclSht = xclBk.Worksheets("32KD") 'Sheet on the Existing File
    xData = xclSht.UsedRange
    
    For iLoop = 1 To UBound(xData, 1)

'Get Second Column label - Could be Frame #
'------------------------------------------------------------------------------
        sTempString = xData(iLoop, 2)
        If sTempString <> "" And Left$(sTempString, 4) = "32KD" Then
            iFrame = Val(Mid$(sTempString, 12, 1))
            If iFrame > gcMAXFRAME + 1 Then Exit For
        End If
        
'Get First Column label - Slot #
'------------------------------------------------------------------------------
        sTempString = xData(iLoop, 1)
        
'If Column not blank and we have a frame number
'------------------------------------------------------------------------------
        If sTempString <> "" And iFrame > 0 Then
            
'Determine current slot
'------------------------------------------------------------------------------
            iSlot = Val(sTempString)
                        
            For iLoop2 = 2 To UBound(xData, 2)
            
'Get third Column label - Slot type
'------------------------------------------------------------------------------
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 6) = "Module" Then
                    sTempString = xData(iLoop, iLoop2)
                    SType = UCase(Left$(sTempString, 3))
            
'Determine Slot type
'------------------------------------------------------------------------------
                    If SType = "KAI" Then
                        SType = "KAI16"
                    ElseIf SType = "KDI" Then
                        SType = "KDI16"
                    ElseIf SType = "KAO" Then
                        SType = "KAO16"
                    ElseIf SType = "KDO" Then
                        SType = "KDO16"
                    ElseIf SType = "KRL" Then
                        SType = "KRL16"
                    ElseIf SType = "DRC" Then
                        SType = "DRC16E"
                    ElseIf SType = "MCU" Then
                        SType = "MCU32E"
                    ElseIf SType = "RCU" Then
                        SType = "RCU"
                    ElseIf SType = "ANI" Then
                        SType = "ANI512"
                    Else
                        SType = ""
                    End If
                    
                    gvaFrame(iFrame - 1).Slot(iSlot - 1).SType = SType
                End If
                
'Get Fifth Column label - In Chan
'------------------------------------------------------------------------------
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 5) = "Input" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iPos = InStr(sTempString, "-")
                        iChan = Val(Left$(sTempString, iPos - 1))
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).InChan = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).InChan = 0
                    End If
                End If
                
                If sTempString = "First Input" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iChan = Val(sTempString)
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).InChan = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).InChan = 0
                    End If
                End If

'Get Sixth Column label - Out Chan
'------------------------------------------------------------------------------
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 6) = "Output" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iPos = InStr(sTempString, "-")
                        iChan = Val(Left$(sTempString, iPos - 1))
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).OutChan = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).OutChan = 0
                    End If
                End If
                
                If sTempString = "First Output" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iChan = Val(sTempString)
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).OutChan = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).OutChan = 0
                    End If
                End If
                
'Get Seventh Column label - Opto
'------------------------------------------------------------------------------
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 4) = "Opto" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iPos = InStr(sTempString, "-")
                        iChan = Val(Left$(sTempString, iPos - 1))
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Opto = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Opto = 0
                    End If
                End If
                
                If sTempString = "First Opto" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iChan = Val(sTempString)
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Opto = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Opto = 0
                    End If
                End If
                
'Get Eighth Column label - Relay
'------------------------------------------------------------------------------
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 5) = "Relay" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iPos = InStr(sTempString, "-")
                        iChan = Val(Left$(sTempString, iPos - 1))
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Relay = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Relay = 0
                    End If
                End If
                
                If sTempString = "First Relay" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iChan = Val(sTempString)
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Relay = iChan
                    Else
                        gvaFrame(iFrame - 1).Slot(iSlot - 1).Relay = 0
                    End If
                End If
                
'See if console attached
'------------------------------------------------------------------------------
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 7) = "Console" Then
                    sTempString = xData(iLoop, iLoop2)
                    If sTempString <> "" Then
                        iChan = Val(sTempString)
                        gvaConsoleInfo(iChan - 1).Frame = iFrame
                        gvaConsoleInfo(iChan - 1).Slot = iSlot
                    End If
                End If
            Next
        End If
    Next
'------------------------------------------------------------------------------
'Read Individual Console Info
'------------------------------------------------------------------------------
    For iLoop2 = 0 To iConsoleCount - 1
        gvaConsoleInfo(iLoop2).ConsoleNumber = iLoop2
        sTempString = "Console #" & iLoop2 + 1
        iCount = UBound(sSheets)
        For iLoop = 1 To iCount
            If sSheets(iLoop) = sTempString Then Exit For
        Next
        If iLoop > iCount Then
            sTempString = "Console " & Chr(iLoop2 + 65)
            For iLoop = 1 To iCount
                If sSheets(iLoop) = sTempString Then Exit For
            Next
            If iLoop > iCount Then
                Exit For
            End If
        End If
        
        Set xclSht = xclBk.Worksheets(sTempString) 'Sheet on the Existing File
        
        xData = xclSht.UsedRange
        
        sTempString = xData(1, 1)
        gvaConsoleInfo(iLoop2).ConsoleName = sTempString
        
        iMax = 1
        For iLoop = 1 To UBound(xData, 2)
            sTempString = xData(1, iLoop)
            iTemp = Val(sTempString)
            iMax = IIf(iTemp > iMax, iTemp, iMax)
        Next
        gvaConsoleInfo(iLoop2).ConsoleSize = iMax
        
        For iLoop = 4 To UBound(xData, 2)
            sTempString = xData(1, iLoop)
            iSlot = Val(sTempString) - 1
            If iSlot > 0 And iSlot <= 40 Then
                sTempString = xData(2, iLoop)
                gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).SType = sTempString
'                Select Case sTempString
'                    Case "blank"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLEBLANK
'                    Case "Blank"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLEBLANK
'                    Case "Input"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLEINPUTMODULE
'                    Case "Control Rm"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLECTRLROOMMODULE
'                    Case "Studio Mon"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLESTUDIOMODULE
'                    Case "Remote Ctl"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLEREMOTECTRLMODULE
'                    Case "Console Ctl"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLECONTROLMODULE
'                    Case "Return"
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLERETURNMODULE
'                    Case Else
'                        gvaConsoleInfo(iLoop2).ConsoleStrip(iSlot).Type = gcCONSOLEBLANK
'                End Select
            End If
        Next
    Next
    
'Close spreadsheet
'------------------------------------------------------------------------------
    xclApp.Quit
    Set xclApp = Nothing
    Set xclSht = Nothing
    Set xclBk = Nothing




'Open ini file
'------------------------------------------------------------------------------
    sTempString = gvsPath & "DemoSetup.ini"
    
    If Dir(sTempString) <> "" Then Kill sTempString
    
    iniFile.FileName = sTempString
    
    iniFile.Application = "SYSTEM"
    
    iniFile.Parameter = "Name"
    iniFile.Value = sName
    
    iniFile.Parameter = "Inputs"
    iniFile.Value = iInCount
    
    iniFile.Parameter = "Outputs"
    iniFile.Value = iOutCount
    
    iniFile.Parameter = "Frame Count"
    iniFile.Value = iFrame
    
    iniFile.Parameter = "Console Count"
    iniFile.Value = iConsoleCount
    
'For each frame
'------------------------------------------------------------------------------
    For iLoop = 0 To iFrame - 1
    'For each slot
'------------------------------------------------------------------------------
        For iLoop2 = 0 To 20
            iCount = 0
            sTempString = "SLOT " & iLoop + 1 & "-" & iLoop2 + 1
            iniFile.Application = sTempString
            
'Save Module Type
'------------------------------------------------------------------------------
            iniFile.Parameter = "Type"
            iniFile.Value = gvaFrame(iLoop).Slot(iLoop2).SType
            
'Save In Chan
'------------------------------------------------------------------------------
            iniFile.Parameter = "In Chan"
            iTemp = gvaFrame(iLoop).Slot(iLoop2).InChan
            sTempString = IIf(iTemp = 0, "", iTemp)
            iniFile.Value = sTempString
            
'Save Out Chan
'------------------------------------------------------------------------------
            iniFile.Parameter = "Out Chan"
            iTemp = gvaFrame(iLoop).Slot(iLoop2).OutChan
            sTempString = IIf(iTemp = 0, "", iTemp)
            iniFile.Value = sTempString
            
'Save Relay
'------------------------------------------------------------------------------
            iniFile.Parameter = "Relay"
            iTemp = gvaFrame(iLoop).Slot(iLoop2).Relay
            sTempString = IIf(iTemp = 0, "", iTemp)
            iniFile.Value = sTempString
            
'Save Opto
'------------------------------------------------------------------------------
            iniFile.Parameter = "Opto"
            iTemp = gvaFrame(iLoop).Slot(iLoop2).Opto
            sTempString = IIf(iTemp = 0, "", iTemp)
            iniFile.Value = sTempString

        Next
    Next
    
'Save Console Info
'------------------------------------------------------------------------------
    For iLoop = 0 To iConsoleCount - 1
        sTempString = "CONSOLE " & iLoop + 1
        iniFile.Application = sTempString

'Save Console Size
'------------------------------------------------------------------------------
        iniFile.Parameter = "Size"
        iTemp = gvaConsoleInfo(iLoop).ConsoleSize
        iniFile.Value = iTemp
        
'Save Frame
'------------------------------------------------------------------------------
        iniFile.Parameter = "Frame"
        iTemp = gvaConsoleInfo(iLoop).Frame
        iniFile.Value = iTemp
        
'Save Slot
'------------------------------------------------------------------------------
        iniFile.Parameter = "Slot"
        iTemp = gvaConsoleInfo(iLoop).Slot
        iniFile.Value = iTemp
        
'Save First Port
'------------------------------------------------------------------------------
        iniFile.Parameter = "Port"
        iTemp = gvaConsoleInfo(iLoop).Port
        iniFile.Value = iTemp
            
        For iLoop2 = 0 To gvaConsoleInfo(iLoop).ConsoleSize - 1
            sTempString = "Module " & iLoop + 1 & "-" & iLoop2 + 1
            iniFile.Application = sTempString
            
            
'Determine Module Type
'------------------------------------------------------------------------------
            iniFile.Parameter = "Type"
            iniFile.Value = gvaConsoleInfo(iLoop).ConsoleStrip(iLoop2).SType
        Next
    Next
    
'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "Completed"
    
    Exit Sub

ErrorMsg:
    sTempString = "Oops"
    sTempString = ": Error # " + _
        Str$(Err.Number) + " - " + Err.Description
Resume Next
    
End Sub
'******************************************************************************
'* Private Sub cmdStart_Click()
'*
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 04/30/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Function called when Start button is clicked
'* Gets Database File name and Excel file
'* Read excel file and saves to Swithcer database or files for future loading
'*
'*
'******************************************************************************
Private Sub cmdStart_Click()
Dim sExcelFile As String, sDatabase As String, sTempString As String
Dim sName As String
Dim iPos As Integer, iTemp As Integer, iLoop As Integer, iLoop2 As Integer
Dim iType As Integer, iChan As Integer, iCount As Integer, iLoop3 As Integer
Dim iInCount As Integer, iOutCount As Integer, iConsoleCount As Integer
Dim iMax As Integer, iSlot As Integer, iFactor As Integer
Dim iConsoles(4) As Integer
Dim lMFD() As Long
Dim tMFD As Boolean
Dim dbWorkingAlphaDB As Database
Dim rstLabel As Recordset
Dim xclApp As Object 'Excel.Application
Dim xData As Variant
Dim xclRange As Excel.Range
Dim xclBk As Excel.Workbook         'As Object
Dim xclSht As Excel.Worksheet       'As Object
Dim lTemp As Long

    On Error GoTo ErrorMsg

    sDatabase = GetFileName("Switcher.mdb", "mdb", 1)

'If no filename returned just exit
'------------------------------------------------------------------------------
    If sDatabase = "" Then Exit Sub
    If Dir(sDatabase) = "" Then Exit Sub
            
     Set xclApp = CreateObject("Excel.Application") 'New Excel.Application
    sExcelFile = GetFileName("Excel", "xls", 1)
    If Dir(sExcelFile) = "" Then Exit Sub
    Set xclBk = xclApp.Workbooks.Open(sExcelFile) 'Path of an existing Excel File
    
'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "In Process"
    DoEvents
    
'------------------------------------------------------------------------------
'Read Sytem Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("System") 'Sheet on the Existing File
    xData = xclSht.UsedRange
    
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        If sTempString = "Name:" Then
            sName = xData(iLoop, 2)
        ElseIf Left$(sTempString, 6) = "Inputs" Then
            iInCount = Val(xData(iLoop, 2))
        ElseIf Left$(sTempString, 7) = "Outputs" Then
            iOutCount = Val(xData(iLoop, 2))
        ElseIf Left$(sTempString, 8) = "Consoles" Then
            iConsoleCount = Val(xData(iLoop, 2))
        ElseIf sTempString = "8" Then
            iConsoles(0) = Val(xData(iLoop, 2))
        ElseIf sTempString = "16" Then
            iConsoles(1) = Val(xData(iLoop, 2))
        ElseIf sTempString = "24" Then
            iConsoles(2) = Val(xData(iLoop, 2))
        ElseIf sTempString = "32" Then
            iConsoles(3) = Val(xData(iLoop, 2))
        ElseIf sTempString = "40" Then
            iConsoles(4) = Val(xData(iLoop, 2))
        End If
    
    Next
    
''------------------------------------------------------------------------------
''Read Colors 32KD Info
''------------------------------------------------------------------------------
'    Set xclSht = xclBk.Worksheets("32KD") 'Sheet on the Existing File
'    For iLoop = 1 To 21
'        Set xclRange = xclSht.Range(xclSht.Cells(2 + iLoop, 1), xclSht.Cells(2 + iLoop, 1))
'        lTemp = xclRange.Interior.Color
'    Next

'------------------------------------------------------------------------------
'Read Sources Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Sources") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    ReDim gvaInAlphas(iInCount)
    ReDim gvaOptoAlphas(iInCount)
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaInAlphas(iChan).Channel = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 10) = "Chan Label" Then
                    gvaInAlphas(iChan).Label = xData(iLoop, iLoop2)
                
                ElseIf Left$(sTempString, 10) = "LocalLabel" Then
                    gvaInAlphas(iChan).LocalAlpha = xData(iLoop, iLoop2)
                
                ElseIf Left$(sTempString, 6) = "Linked" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp > 1, 0, iTemp)
                    gvaInAlphas(iChan).Link = iTemp
                
                ElseIf Left$(sTempString, 6) = "Hidden" Then
                    gvaInAlphas(iChan).Hidden = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaInAlphas(iChan).Note = xData(iLoop, iLoop2)
                
                ElseIf Left$(sTempString, 10) = "Location #" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).Location = iTemp
                    
                ElseIf Left$(sTempString, 11) = "Source Type" Then
                    gvaInAlphas(iChan).Type = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 6) = "IFB/MM" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocChan = iTemp
                               
                ElseIf Left$(sTempString, 3) = "IFB" Then
                    gvaInAlphas(iChan).IFB = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 13) = "Timer Restart" Then
                    gvaInAlphas(iChan).Timer = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 3) = "GPI" Then
                    gvaInAlphas(iChan).GPIType = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 6) = "OptoOn" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocOptoOn = iTemp
                
                ElseIf Left$(sTempString, 7) = "OptoOff" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocOptoOff = iTemp
                
                ElseIf Left$(sTempString, 9) = "OptoCough" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocOptoCough = iTemp
                
                ElseIf Left$(sTempString, 3) = "Cue" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocOptoCueOn = iTemp
                
                ElseIf Left$(sTempString, 12) = "Opto Off LED" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocOptoCueOff = iTemp
                
                ElseIf Left$(sTempString, 3) = "GPO" Then
                    gvaInAlphas(iChan).GPOType = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 7) = "RelayOn" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocRelayOn = iTemp
                
                ElseIf Left$(sTempString, 8) = "RelayOff" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaInAlphas(iChan).AssocRelayOff = iTemp
                
                End If
            
            Next
            iChan = iChan + 1
            If iChan > iInCount Then Exit For
        End If
    Next

'------------------------------------------------------------------------------
'Read Destination Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Destinations") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    ReDim gvaOutAlphas(iOutCount)
    ReDim gvaRelayAlphas(iOutCount)
    
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaOutAlphas(iChan).Channel = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 10) = "Chan Label" Then
                    gvaOutAlphas(iChan).Label = xData(iLoop, iLoop2)
                
                ElseIf Left$(sTempString, 11) = "Local Label" Then
                    gvaOutAlphas(iChan).LocalAlpha = xData(iLoop, iLoop2)
                
                ElseIf Left$(sTempString, 6) = "Linked" Then
                    gvaOutAlphas(iChan).Link = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 6) = "Hidden" Then
                    gvaOutAlphas(iChan).Hidden = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaOutAlphas(iChan).Note = xData(iLoop, iLoop2)
                
                ElseIf Left$(sTempString, 10) = "Location #" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOutAlphas(iChan).Location = iTemp
                
                ElseIf Left$(sTempString, 10) = "Bus Type #" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp > 15, 0, iTemp)
                    gvaOutAlphas(iChan).Type = iTemp
                
                ElseIf Left$(sTempString, 10) = "AssocRelay" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOutAlphas(iChan).AssocRelay = iTemp
                
                ElseIf Left$(sTempString, 12) = "RelayControl" Then
                    gvaOutAlphas(iChan).RelayControl = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 9) = "RelayType" Then
                    gvaOutAlphas(iChan).RelayType = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 14) = "Utility-Switch" Then
                    gvaOutAlphas(iChan).Switch = Val(xData(iLoop, iLoop2))
                
                ElseIf Left$(sTempString, 13) = "Utility-Fader" Then
                    gvaOutAlphas(iChan).Fader = Val(xData(iLoop, iLoop2))
                
                End If
            
            Next
            iChan = iChan + 1
            If iChan > iOutCount Then Exit For
        End If
    Next

'------------------------------------------------------------------------------
'Read Opto Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Opto") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaOptoAlphas(iChan).Channel = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 4) = "Name" Then
                    gvaOptoAlphas(iChan).Label = xData(iLoop, iLoop2)
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaOptoAlphas(iChan).Note = xData(iLoop, iLoop2)
                ElseIf Left$(sTempString, 4) = "Type" Then
                    gvaOptoAlphas(iChan).Type = Val(xData(iLoop, iLoop2))
                ElseIf Left$(sTempString, 5) = "Salvo" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOptoAlphas(iChan).Salvo = iTemp
                ElseIf Left$(sTempString, 5) = "Input" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOptoAlphas(iChan).Input = iTemp
                ElseIf Left$(sTempString, 6) = "Output" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOptoAlphas(iChan).Output = iTemp
                ElseIf Left$(sTempString, 5) = "Relay" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOptoAlphas(iChan).Relay = iTemp
                End If
            Next
            iChan = iChan + 1
        End If
    Next

'------------------------------------------------------------------------------
'Read Relay Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Relay") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaRelayAlphas(iChan).Channel = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 4) = "Name" Then
                    gvaRelayAlphas(iChan).Label = xData(iLoop, iLoop2)
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaRelayAlphas(iChan).Note = xData(iLoop, iLoop2)
                End If
            Next
            iChan = iChan + 1
        End If
    Next

'------------------------------------------------------------------------------
'Read Location Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Location") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaLocationAlphas(iChan).Channel = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 13) = "Location Name" Then
                    gvaLocationAlphas(iChan).Label = xData(iLoop, iLoop2)
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaLocationAlphas(iChan).Note = xData(iLoop, iLoop2)
                End If
            Next
            iChan = iChan + 1
        End If
    Next

'------------------------------------------------------------------------------
'Read Console Name Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Console Name") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaConsoleAlphas(iChan).Channel = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 12) = "Console Name" Then
                    gvaConsoleAlphas(iChan).Label = xData(iLoop, iLoop2)
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaConsoleAlphas(iChan).Note = xData(iLoop, iLoop2)
                End If
            Next
            iChan = iChan + 1
        End If
    Next

'------------------------------------------------------------------------------
'Read Opto Relay Sets
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("RC") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            gvaOptoRelay(iChan).Number = iChan + 1
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 8) = "Set Name" Then
                    gvaOptoRelay(iChan).Label = xData(iLoop, iLoop2)
                ElseIf Left$(sTempString, 4) = "Opto" Then
                    iPos = Val(Mid$(sTempString, 6, 1)) - 1
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOptoRelay(iChan).Opto(iPos) = iTemp
                ElseIf Left$(sTempString, 5) = "Relay" Then
                    iPos = Val(Mid$(sTempString, 7, 1)) - 1
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaOptoRelay(iChan).Relay(iPos) = iTemp
                ElseIf Left$(sTempString, 5) = "Notes" Then
                    gvaOptoRelay(iChan).Notes = xData(iLoop, iLoop2)
                End If
            Next
            iChan = iChan + 1
        End If
    Next

'------------------------------------------------------------------------------
'Read Console Config Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Console Config") 'Sheet on the Existing File

    xData = xclSht.UsedRange
    iChan = 0
'
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        iTemp = Val(sTempString)
        
        If iTemp = iChan + 1 Then
            For iLoop2 = 2 To UBound(xData, 2)
                sTempString = xData(1, iLoop2)
                If Left$(sTempString, 10) = "Location #" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).Location = iTemp
                ElseIf Left$(sTempString, 3) = "Mic" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).Mic = iTemp
                ElseIf Left$(sTempString, 7) = "Monitor" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).Speakers = iTemp
                ElseIf Left$(sTempString, 8) = "Cue Spkr" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).CueSpeaker = iTemp
                ElseIf Left$(sTempString, 7) = "Cue Bus" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).CueBus = iTemp
                ElseIf Left$(sTempString, 8) = "Talkback" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).TalkbackBus = iTemp
                ElseIf Left$(sTempString, 9) = "HP Output" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).Headphones = iTemp
                ElseIf Left$(sTempString, 6) = "HP Bus" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).HeadphoneBus = iTemp
                ElseIf Left$(sTempString, 9) = "Dim Value" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    gvaConsoleData(iChan).DimValue = iTemp
                ElseIf Left$(sTempString, 13) = "Source Select" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    gvaConsoleData(iChan).SourceSelect = iTemp
                ElseIf Left$(sTempString, 10) = "Cancel Cue" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    gvaConsoleData(iChan).CancelCue = iTemp
                ElseIf Left$(sTempString, 8) = "Cue Type" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    gvaConsoleData(iChan).CueType = iTemp
                ElseIf Left$(sTempString, 5) = "Fader" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    gvaConsoleData(iChan).Fader = iTemp
                ElseIf Left$(sTempString, 11) = "Timer Start" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).TimerStart = iTemp
                ElseIf Left$(sTempString, 10) = "Timer Stop" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).TimerStop = iTemp
                ElseIf Left$(sTempString, 10) = "Timer Hold" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).TimerHold = iTemp
                ElseIf Left$(sTempString, 11) = "Timer Reset" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).TimerReset = iTemp
                ElseIf Left$(sTempString, 14) = "Timer External" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).TimerExtReset = iTemp
                ElseIf Left$(sTempString, 8) = "Meter #1" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).MeterBus(0) = iTemp
                ElseIf Left$(sTempString, 8) = "Meter #2" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).MeterBus(1) = iTemp
                ElseIf Left$(sTempString, 8) = "Meter #3" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).MeterBus(2) = iTemp
                ElseIf Left$(sTempString, 8) = "Meter #4" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).MeterBus(3) = iTemp
                ElseIf Left$(sTempString, 8) = "Meter #5" Then
                    iTemp = Val(xData(iLoop, iLoop2))
                    iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                    gvaConsoleData(iChan).MeterBus(4) = iTemp
                End If
            Next
            iChan = iChan + 1
        End If
    Next

'------------------------------------------------------------------------------
'Read Individual Console Info
'------------------------------------------------------------------------------
    For iLoop3 = 1 To iConsoleCount
        gvaConsoleInfo(iLoop3).ConsoleNumber = iLoop3
        sTempString = "Console #" & iLoop3
        Set xclSht = xclBk.Worksheets(sTempString) 'Sheet on the Existing File
        
        xData = xclSht.UsedRange
        
        sTempString = xData(1, 1)
        gvaConsoleInfo(iLoop3).ConsoleName = sTempString
        
        iMax = 1
        For iLoop = 2 To UBound(xData, 2)
            sTempString = xData(1, iLoop)
            iTemp = Val(sTempString)
            iMax = IIf(iTemp > iMax, iTemp, iMax)
        Next
        gvaConsoleInfo(iLoop3).ConsoleSize = iMax
        ReDim lMFD(iMax)
        
        
'        tFound = False
        iChan = 0
        For iLoop = 1 To UBound(xData, 1)
            tMFD = False
            sTempString = Trim(xData(iLoop, 1))
            If sTempString = "MFD Router Control" Then
                tMFD = True
                iFactor = 0
            ElseIf sTempString = "MFD Ch Mode" Then
                tMFD = True
                iFactor = 1
            ElseIf sTempString = "MFD Ch Pan/Balance" Then
                tMFD = True
                iFactor = 2
            ElseIf sTempString = "MFD Rec Split & Pre/Post" Then
                tMFD = True
                iFactor = 5
            ElseIf sTempString = "MFD Send Pre/Post" Then
                tMFD = True
                iFactor = 3
            ElseIf sTempString = "MFD Mix-Minus" Then
                tMFD = True
                iFactor = 4
            ElseIf sTempString = "MFD Ch Phase" Then
                tMFD = True
                iFactor = 12
            ElseIf sTempString = "MFD Proc" Then
                tMFD = False
            End If
            
            If tMFD = True Then
                For iLoop2 = 4 To UBound(xData, 2)
                    sTempString = xData(1, iLoop2)
                    iSlot = Val(sTempString)
                    sTempString = xData(iLoop, iLoop2)
                    
                    If sTempString = "Show" Or sTempString = "Yes" Then
                        lMFD(iSlot) = lMFD(iSlot) Or 2 ^ iFactor
                    End If
                    
                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).MFDOptions = lMFD(iSlot)
                    
                Next
            Else
                iTemp = Val(sTempString)
                If iTemp = iChan + 1 Then
     '           If tFound = True Then
                    For iLoop2 = 4 To UBound(xData, 2)
                        sTempString = xData(1, iLoop2)
                        iSlot = Val(sTempString)
                        If iChan = 0 Then
                            sTempString = xData(2, iLoop2)
                            Select Case sTempString
                                Case "blank"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLEBLANK
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 0
                                Case "Blank"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLEBLANK
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 0
                                Case "Input"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLEINPUTMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 12
                                Case "Control Rm"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLECTRLROOMMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 16
                                Case "Studio Mon"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLESTUDIOMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 8
                                Case "Remote Ctl"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLEREMOTECTRLMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 0
                                Case "Console Ctl"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLECONTROLMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 16
                                Case "Return"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLERETURNMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 12
                                Case "SLInput"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLESLINPUTMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 8
                                Case "SLControl Rm"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLESLCTRLROOMMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 8
                                Case "SLConsole Ctl"
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLESLCONTROLMODULE
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 9
                                Case Else
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type = gcCONSOLEBLANK
                                    gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).ButtonCount = 0
                            End Select
                        End If
                        
                        sTempString = xData(iLoop, iLoop2)
                        iTemp = Val(sTempString)
                        
'If no button item set as 0
'------------------------------------------------------------------------------
                        iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                        
                        gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Buttons(iChan).Item = iTemp
                        
                        
                        iType = gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Type
                        If iType = gcCONSOLEBLANK Then
                            iType = 255
                        ElseIf iType = gcCONSOLECTRLROOMMODULE Or iType = gcCONSOLESLCTRLROOMMODULE Then
                            iType = gcBTYPEMONITORSRCSEL
                        ElseIf iType = gcCONSOLECONTROLMODULE Or iType = gcCONSOLESLCONTROLMODULE Then
                            iType = gcBTYPECNSLMETERSRCSEL
                        ElseIf iType = gcCONSOLESTUDIOMODULE Then
                            iType = gcBTYPEMONITORSRCSEL
                        ElseIf iType = gcCONSOLEINPUTMODULE Or iType = gcCONSOLESLINPUTMODULE Then
                            sTempString = xData(iLoop, 2)
                            
                            Select Case sTempString
                                Case "Src Sel"
                                    iType = gcBTYPESRCSEL
                                Case "Bus Assn"
                                    iType = gcBTYPEBUSSEL
                                Case "SOLO"
                                    iType = gcBTYPESOLOBUS
                                Case "CUE", "Cue"
                                    iType = gcBTYPECUEBUS
                                Case "IFB"
                                    iType = gcBTYPEIFB
                                Case Else
                                    iType = 255
                            End Select
                        Else
                            iType = 255
                        End If
                        
                        gvaConsoleInfo(iLoop3).ConsoleStrip(iSlot).Buttons(iChan).Type = iType
                        
                        
                    Next
                    iChan = iChan + 1
                End If
            End If
        Next
    Next

    xclApp.Quit
    Set xclApp = Nothing
    Set xclSht = Nothing
    Set xclBk = Nothing

'    Exit Sub

'------------------------------------------------------------------------------
'Save Info
'------------------------------------------------------------------------------
    Set dbWorkingAlphaDB = Workspaces(0).OpenDatabase(sDatabase)
    
'------------------------------------------------------------------------------
'Save Input Info
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM InptAlphas ORDER BY [Chan Num]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0
    
    While Not rstLabel.EOF
        
        If rstLabel![Chan Num] = gvaInAlphas(iPos).Channel Then
            iTemp = gvaInAlphas(iPos).Channel
            rstLabel.Edit
            
            sTempString = gvaInAlphas(iPos).Label
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Label] = sTempString
            End If
            
            sTempString = gvaInAlphas(iPos).LocalAlpha
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
                sTempString = rstLabel![Label]
            End If
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            rstLabel![LocalLabel] = sTempString
            rstLabel![Location] = gvaInAlphas(iPos).Location
            rstLabel![Type] = gvaInAlphas(iPos).Type
            If gvaInAlphas(iPos).Type = 1 Then
                gvaInAlphas(iPos).Mute = 1
            End If
            If gvaInAlphas(iPos).Type = 2 Then
                gvaInAlphas(iPos).MixMinus = 1
            End If
            rstLabel![MixMinus] = gvaInAlphas(iPos).MixMinus
            rstLabel![Mute] = gvaInAlphas(iPos).Mute
            rstLabel![IFB] = gvaInAlphas(iPos).IFB
            rstLabel![Timer] = gvaInAlphas(iPos).Timer
            If Left$(gvaInAlphas(iPos).Label, 1) = "{" Then
                gvaInAlphas(iPos).Hidden = 1
            End If
            rstLabel![Hidden] = gvaInAlphas(iPos).Hidden
            rstLabel![Linked] = gvaInAlphas(iPos).Link
            rstLabel![AssocOutput] = gvaInAlphas(iPos).AssocChan
            rstLabel![GPI] = gvaInAlphas(iPos).GPIType
            rstLabel![OptoOn] = gvaInAlphas(iPos).AssocOptoOn
            rstLabel![OptoOff] = gvaInAlphas(iPos).AssocOptoOff
            rstLabel![OptoCough] = gvaInAlphas(iPos).AssocOptoCough
            rstLabel![CueOn] = gvaInAlphas(iPos).AssocOptoCueOn
            rstLabel![CueOff] = gvaInAlphas(iPos).AssocOptoCueOff
            rstLabel![GPO] = gvaInAlphas(iPos).GPOType
            rstLabel![RelayOn] = gvaInAlphas(iPos).AssocRelayOn
            rstLabel![RelayOff] = gvaInAlphas(iPos).AssocRelayOff
            sTempString = gvaInAlphas(iPos).Note
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            rstLabel.Update
            iPos = iPos + 1
        Else
            iPos = iPos
        
        End If
        
            If iPos > iInCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend
    
    rstLabel.Close

'------------------------------------------------------------------------------
'Save Output Info
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM OutptAlphas ORDER BY [Chan Num]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0
    
    While Not rstLabel.EOF
        
        If rstLabel![Chan Num] = gvaOutAlphas(iPos).Channel Then
            iTemp = gvaOutAlphas(iPos).Channel
            rstLabel.Edit
            
            sTempString = gvaOutAlphas(iPos).Label
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            
            Else
                rstLabel![Label] = sTempString
            End If
            
            sTempString = gvaOutAlphas(iPos).LocalAlpha
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
                sTempString = rstLabel![Label]
            End If
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            rstLabel![LocalLabel] = sTempString
            rstLabel![Location] = gvaOutAlphas(iPos).Location
            rstLabel![Type] = gvaOutAlphas(iPos).Type
            Select Case gvaOutAlphas(iPos).Type
                Case 0      'Router
                    gvaOutAlphas(iPos).Switch = 0
                    gvaOutAlphas(iPos).Fader = 0
                Case 1      'Program
                    gvaOutAlphas(iPos).Switch = 0
                    gvaOutAlphas(iPos).Fader = 0
                Case 2      'Audition
                    gvaOutAlphas(iPos).Switch = 1
                    gvaOutAlphas(iPos).Fader = 1
                Case 3      'Send
                    gvaOutAlphas(iPos).Switch = 1
                    gvaOutAlphas(iPos).Fader = 1
                Case 4      'Aux
                    gvaOutAlphas(iPos).Switch = 1
                    gvaOutAlphas(iPos).Fader = 1
                Case 5      'Off Line
                    gvaOutAlphas(iPos).Switch = 1
                    gvaOutAlphas(iPos).Fader = 0
                Case 6      'Record
                    gvaOutAlphas(iPos).Switch = 1
                    gvaOutAlphas(iPos).Fader = 1
                Case 7      'Utility
'                    gvaOutAlphas(iPos).Switch = 0
'                    gvaOutAlphas(iPos).Fader = 0
                Case 8
                Case 9
                Case 10
                Case 11
                Case 12     'Mix Minus
                    gvaOutAlphas(iPos).Switch = 0
                    gvaOutAlphas(iPos).Fader = 0
                Case 13     'Cue
                    gvaOutAlphas(iPos).Switch = 1
                    gvaOutAlphas(iPos).Fader = 1
                Case 14     'Speaker
                    gvaOutAlphas(iPos).Mute = 1
                    gvaOutAlphas(iPos).Switch = 0
                    gvaOutAlphas(iPos).Fader = 0
                Case 15     'Head Phones
                    gvaOutAlphas(iPos).Switch = 0
                    gvaOutAlphas(iPos).Fader = 0
            
            End Select
            
            rstLabel![Mute] = gvaOutAlphas(iPos).Mute
            If Left$(gvaOutAlphas(iPos).Label, 1) = "{" Then
                gvaOutAlphas(iPos).Hidden = 1
            End If
            rstLabel![Hidden] = gvaOutAlphas(iPos).Hidden
            rstLabel![Linked] = gvaOutAlphas(iPos).Link
            rstLabel![AuxId] = gvaOutAlphas(iPos).AuxId
            rstLabel![Switch] = gvaOutAlphas(iPos).Switch
            rstLabel![Fader] = gvaOutAlphas(iPos).Fader
            rstLabel![AllowMM] = 1
            rstLabel![AssocInput] = gcNOTDEFINED
            rstLabel![AssocRelay] = gvaOutAlphas(iPos).AssocRelay
            rstLabel![RelayControl] = gvaOutAlphas(iPos).RelayControl
            rstLabel![RelayType] = gvaOutAlphas(iPos).RelayType
            sTempString = gvaOutAlphas(iPos).Note
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            
            rstLabel.Update
            iPos = iPos + 1
        End If
        
           If iPos > iOutCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend

'Set Aux Ids
'------------------------------------------------------------------------------
    iPos = 1
    rstLabel.MoveFirst
    While Not rstLabel.EOF
        iType = rstLabel![Type]
        
'If Aux, Record or Send - set Aux Chan ID
'------------------------------------------------------------------------------
        rstLabel.Edit
        If iType = 3 Or iType = 4 Or iType = 6 Then
            rstLabel![AuxId] = iPos
            iPos = iPos + 1
        Else
            rstLabel![AuxId] = gcNOTDEFINED
        End If
        rstLabel.Update
        rstLabel.MoveNext
    Wend

    rstLabel.Close

'------------------------------------------------------------------------------
'Save Opto Info
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM OptoAlphas ORDER BY [Chan Num]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0
    
    While Not rstLabel.EOF
        
        If rstLabel![Chan Num] = gvaOptoAlphas(iPos).Channel Then
            iTemp = gvaOptoAlphas(iPos).Channel
            rstLabel.Edit
            
            sTempString = gvaOptoAlphas(iPos).Label
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            
            Else
                rstLabel![Label] = sTempString
            End If
            
            rstLabel![Type] = gvaOptoAlphas(iPos).Type
            rstLabel![Input] = gvaOptoAlphas(iPos).Input
            rstLabel![Output] = gvaOptoAlphas(iPos).Output
            rstLabel![Relay] = gvaOptoAlphas(iPos).Relay
            rstLabel![Salvo] = gvaOptoAlphas(iPos).Salvo
            
            sTempString = gvaOptoAlphas(iPos).Note
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            rstLabel.Update
            iPos = iPos + 1
        End If
        
           If iPos > iInCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend

    rstLabel.Close

'------------------------------------------------------------------------------
'Save Relay Info
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM RelayAlphas ORDER BY [Chan Num]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0
    
    While Not rstLabel.EOF
        
        If rstLabel![Chan Num] = gvaRelayAlphas(iPos).Channel Then
            iTemp = gvaRelayAlphas(iPos).Channel
            rstLabel.Edit
            
            sTempString = gvaRelayAlphas(iPos).Label
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            
            Else
                rstLabel![Label] = sTempString
            End If
            
            sTempString = gvaRelayAlphas(iPos).Note
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            rstLabel.Update
            iPos = iPos + 1
        End If
        
           If iPos > iOutCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend

    rstLabel.Close

'------------------------------------------------------------------------------
'Save Console Alpha Info
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM ConsoleAlphas ORDER BY [Chan Num]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0

    While Not rstLabel.EOF
        
        If rstLabel![Chan Num] = gvaConsoleAlphas(iPos).Channel Then
            iTemp = gvaConsoleAlphas(iPos).Channel
            rstLabel.Edit
            
            sTempString = gvaConsoleAlphas(iPos).Label
            If Len(sTempString) > 16 Then sTempString = Left$(sTempString, 16)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            
            Else
                rstLabel![Label] = sTempString
            End If
            
            sTempString = gvaConsoleAlphas(iPos).Note
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            rstLabel.Update
            iPos = iPos + 1
        End If
        
'           If iPos > iCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend

    rstLabel.Close

'------------------------------------------------------------------------------
'Save Location Info
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM LocationAlphas ORDER BY [Chan Num]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0

    While Not rstLabel.EOF
        
        If rstLabel![Chan Num] = gvaLocationAlphas(iPos).Channel Then
            iTemp = gvaLocationAlphas(iPos).Channel
            rstLabel.Edit
            
            sTempString = gvaLocationAlphas(iPos).Label
            If Len(sTempString) > 16 Then sTempString = Left$(sTempString, 16)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            
            Else
                rstLabel![Label] = sTempString
            End If
            
            sTempString = gvaLocationAlphas(iPos).Note
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            rstLabel.Update
            iPos = iPos + 1
        End If
        
'           If iPos > iCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend

'------------------------------------------------------------------------------
'Save Opto Relay Sets
'------------------------------------------------------------------------------
    sTempString = "SELECT * FROM OptoRelaySets ORDER BY [SetNum]"
    Set rstLabel = dbWorkingAlphaDB.OpenRecordset(sTempString, dbOpenDynaset)
    If Not rstLabel.BOF Then rstLabel.MoveFirst
    
    iPos = 0

    While Not rstLabel.EOF
        
        If rstLabel![SetNum] = gvaOptoRelay(iPos).Number Then
            iTemp = gvaOptoRelay(iPos).Number
            rstLabel.Edit
            
            sTempString = gvaOptoRelay(iPos).Label
            If Len(sTempString) > 8 Then sTempString = Left$(sTempString, 8)
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            
            Else
                rstLabel![Label] = sTempString
            End If
            
            For iLoop = 0 To 4
                sTempString = "Opto" & iLoop + 1
                rstLabel.Fields(sTempString) = gvaOptoRelay(iPos).Opto(iLoop)
                sTempString = "Relay" & iLoop + 1
                rstLabel.Fields(sTempString) = gvaOptoRelay(iPos).Relay(iLoop)
            Next
            
            sTempString = gvaOptoRelay(iPos).Notes
            If sTempString = "" Or sTempString = " " Or sTempString = "0" Then
            Else
                rstLabel![Notes] = sTempString
            End If
            rstLabel.Update
            iPos = iPos + 1
        End If
        
'           If iPos > iCount Then rstLabel.MoveLast
        rstLabel.MoveNext
    Wend

    dbWorkingAlphaDB.Close

'------------------------------------------------------------------------------
'Save Console Config Info
'------------------------------------------------------------------------------
    sTempString = gvsPath & sName & ".con"
    Call SaveConsoleConfig(sTempString, gvaConsoleData)

'------------------------------------------------------------------------------
'Save Individual Console Info
'------------------------------------------------------------------------------
    Call SaveConsoleInfo(sName, gvaConsoleInfo, iConsoleCount)

'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "Completed"

'Normal Exit
'------------------------------------------------------------------------------
    Exit Sub
    
ErrorMsg:
    sTempString = "Oops"
    sTempString = ": Error # " + _
        Str$(Err.Number) + " - " + Err.Description
Resume Next

'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "Completed"


End Sub
'******************************************************************************
'* Private Sub cmdXpoints_Click()
'*
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 11/18/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Function called when Xpoints button is clicked
'* Gets Database File name and Excel file
'* Read excel file and saves crosspoints for future loading
'*
'*
'******************************************************************************
Private Sub cmdXpoints_Click()
Dim sExcelFile As String, sTempString As String, SType As String
Dim sName As String
Dim sSheets() As String
Dim iPos As Integer, iTemp As Integer, iLoop As Integer, iLoop2 As Integer
Dim iCount As Integer, iNum As Integer
Dim iXpoints() As Integer
Dim xclApp As Object                                    'Excel.Application
Dim xData As Variant
Dim xclRange As Excel.Range
Dim xclBk As Excel.Workbook         'As Object
Dim xclSht As Excel.Worksheet       'As Object

    On Error GoTo ErrorMsg

'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = ""
    DoEvents

'Open spread sheet
'------------------------------------------------------------------------------
    Set xclApp = CreateObject("Excel.Application") 'New Excel.Application
    sExcelFile = GetFileName("Excel", "xls", 1)
    If Dir(sExcelFile) = "" Then Exit Sub
    Set xclBk = xclApp.Workbooks.Open(sExcelFile) 'Path of an existing Excel File
    
'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "In Process"
    DoEvents
    
    iCount = xclBk.Worksheets.Count
    ReDim sSheets(iCount)
    For iLoop = 1 To iCount
        Set xclSht = xclBk.Worksheets(iLoop) 'Sheet on the Existing File
        sSheets(iLoop) = xclSht.Name
    Next
    
'------------------------------------------------------------------------------
'Read Sytem Info
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("System") 'Sheet on the Existing File
    xData = xclSht.UsedRange
    
    For iLoop = 1 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        If sTempString = "Name:" Then
            sName = xData(iLoop, 2)
            Exit For
        End If
    Next
    
'------------------------------------------------------------------------------
'Read Crosspoints
'------------------------------------------------------------------------------
    Set xclSht = xclBk.Worksheets("Crosspoints") 'Sheet on the Existing File
    xData = xclSht.UsedRange
    
    ReDim iXpoints(UBound(xData, 1), 2)
    
    For iLoop = 2 To UBound(xData, 1)
        sTempString = xData(iLoop, 1)
        If sTempString <> "" Then
            For iLoop2 = 1 To UBound(xData, 2)
            
            
            
'Get third Column label - Slot type
'------------------------------------------------------------------------------
            sTempString = xData(1, iLoop2)
            If Left$(sTempString, 7) = "P-Level" Then
                iTemp = Val(xData(iLoop, iLoop2))
                iTemp = IIf(iTemp > 1, gcNOTDEFINED, iTemp)
                iXpoints(iPos, 0) = iTemp
            ElseIf Left$(sTempString, 6) = "Source" Then
                iTemp = Val(xData(iLoop, iLoop2))
                iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                iXpoints(iPos, 1) = iTemp
            ElseIf Left$(sTempString, 11) = "Destination" Then
                iTemp = Val(xData(iLoop, iLoop2))
                iTemp = IIf(iTemp = 0 Or iTemp = gcNOTDEFINED, gcNOTDEFINED, iTemp - 1)
                iXpoints(iPos, 2) = iTemp
            End If
                
            Next
            iPos = iPos + 1
        End If
    Next
    
    iCount = iPos
    
'Close spreadsheet
'------------------------------------------------------------------------------
    xclApp.Quit
    Set xclApp = Nothing
    Set xclSht = Nothing
    Set xclBk = Nothing

    sTempString = gvsPath & sName
    sTempString = sTempString & " Crosspoints.xpt"
    
    If Dir(sTempString) <> "" Then Kill sTempString
    
'Open Console Config Save file
'------------------------------------------------------------------------------
    iNum = FreeFile
    Open sTempString For Binary Shared As #iNum

'Save Count
'------------------------------------------------------------------------------
    Put #iNum, , iCount

    For iLoop = 0 To iCount - 1
        For iLoop2 = 0 To 2
            iTemp = iXpoints(iLoop, iLoop2)
            Put #iNum, , iTemp
        Next
    Next

    Close

'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "Completed"

'Normal Exit
'------------------------------------------------------------------------------
    Exit Sub
    
ErrorMsg:
    sTempString = "Oops"
    sTempString = ": Error # " + _
        Str$(Err.Number) + " - " + Err.Description
Resume Next

'Set Caption
'------------------------------------------------------------------------------
    lblStatus.Caption = "Completed"

End Sub
'******************************************************************************
'*Private Sub Form_Load()
'*
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 08/11/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Function called when Program starts
'* Sets application Path variable
'*
'*
'******************************************************************************
Private Sub Form_Load()
    gvsPath = App.Path
    If Right$(gvsPath, 1) <> "\" Then gvsPath = gvsPath & "\"

End Sub
